config/routes.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
# SPDX-License-Identifier: AGPL-3.0-or-later

Rails.application.routes.draw do

  get 'sections/show'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root to: 'welcome#index'

  # Agent routes
  resources :agents do
    shallow do
      # Classification routes
      resources :taxonomies do
        member do
          get :filter, to: 'taxonomies/filter#show'
        end
        resources :categories do
          resources :sections
        end
      end
      # Resource routes
      resources :resources
    end
  end

  # User routes
  get '/my/account', to: 'users#show', as: 'account'
  patch '/my/current_agent', to: 'my/agent#switch', as: 'agent_switch'
  get '/my/dashboard', to: 'welcome#dashboard'
  get '/my/peers', to: 'users#index', as: 'users'

  # UUID Resolver
  get '/by-uuid/:uuid', to: 'uuid_resolver#new', as: 'uuid_resolver'

  # Discourse SSO
  get 'authenticate(/:token)', to: 'welcome#authenticate', as: 'authenticate'
  get 'logout', to: 'welcome#logout'
end

app/models/category.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

class Category < ApplicationRecord
  belongs_to :taxonomy
  has_many :sections,
           -> { order(rank: :asc) },
           dependent: :destroy,
           inverse_of: :category

  acts_as_list column: :rank, scope: :taxonomy

  validates :name,
            presence: true,
            uniqueness: { scope: :taxonomy_id },
            length: 3..64
end

app/controllers/categories_controller.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

class CategoriesController < ApplicationController
  before_action :set_category, only: [:new, :show, :edit, :update, :delete, :destroy]

  def index
  end

  def show
    @category = Category.find(params[:id])

    respond_to do |format|
      format.html
      format.js
    end
  end

  def edit
  end

  private

  def set_category
    @category = Category.find_by(id: params[:id]) || Category.new
  end
end

app/helpers/categories_helper.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

module CategoriesHelper
end

app/views/categories/_category.html.erb
<article class="category" id="category-<%= category.id %>">
    <header style="background-color: <%= category.color %>">
        <h1><%= category.taxonomy.name %></h1>
        <h2><%= category.name %></h2>
    </header>
    <p><%= h category.summary %></p>
    <div class="markdown"><%= h category.description %></div>
    <section id="stats"><h3>Info</h3>
        <p><%= pluralize(category.sections_count, 'section') %></p>
        <p><%= pluralize(category.sections.map { |s| s.resources }.sum(&:count) || 0, 'resources') %></p>
    </section>
    <section id="actions">
        <ul>
            <li><%= link_to 'edit', edit_category_path(category) %></li>
        </ul>
    </section>
</article>

app/views/categories/_edit.html.erb
<h3>Edit <%= @category.presence&.name || 'new category' %></h3>
<h2>Context: <%= @taxonomy %></h2>

<%= form_with model: [@taxonomy,@category], url: controller.action_name == 'new' ? taxonomy_categories_path(taxonomy: @taxonomy) : category_path(@category) do |f| %>
    <%= render partial: 'form', locals: { category: category, f: f } %>
<% end %>

app/views/categories/_form.html.erb
<fieldset>
    <%= tag.legend "Categorie..." %>

    <dl>
        <dt><%= f.label :name %></dt>
        <dd><%= f.text_field :name, maxlength: 64, placeholder: 'Se loger' %></dd>

        <dt><%= f.label :summary %></dt>
        <dd><%= f.text_field :summary, maxlength: 136, placeholder: 'Une ferme locale' %></dd>

        <dt><%= f.label :description %></dt>
        <dd><%= f.text_area :description, cols: 72, rows: 10, placeholder: '## Un choix pertinent

La description _peut_ comporter du [Markdown].

[Markdown]: https://www.markdownguide.org/getting-started/' %></dd>

        <dt><%= f.label :color %></dt>
        <dd><%= f.color_field :color, placeholder: '#cc0077 (or: rgba(255 0 0 0.5)' %></dd>
    </dl>
</fieldset>

<%= f.hidden_field :taxonomy_id, value: @category.taxonomy_id %>

<p><%= f.submit 'Save' %></p>

app/views/categories/edit.html.erb
<%= render partial: 'edit', locals: { category: @category } %>

app/views/categories/show.html.erb
<%= @category.inspect %>
<%= render @category %>